---
home: true
heroImage: /logo.png
heroText:  HOJ
tagline: 基于分布式、前后端分离的高性能在线评测系统
action:
  - text: 文档介绍 🔔
    link: /introducition/
    type: primary
  - text: 快速部署
    link: /deploy/docker/
features:
- title: 分布式
  details: 支持多台判题服务弹性增减
- title: 高效化
  details: 采用前后端分离，开发迅速，使用高性能可复用判题沙盒
- title: 定制化
  details: 网站高度集中配置，支持定制化修改
- title: 安全化
  details: 判题使用 cgroup 隔离用户程序，网站权限控制完善
- title: 多样化
  details: 独有自身判题服务，同时支持其它知名OJ题目的提交判题
footer: MIT Licensed | Copyright © 2022.10.16 @Author Himit_ZH  QQ Group:598587305
---

[![Java](https://img.shields.io/badge/Java-1.8-informational)](http://openjdk.java.net/)
[![Spring Boot](https://img.shields.io/badge/Spring%20Boot-2.2.6.RELEASE-success)](https://spring.io/projects/spring-boot)
[![SpringCloud Alibaba](https://img.shields.io/badge/Spring%20Cloud%20Alibaba-2.2.1.RELEASE-success)](https://spring.io/projects/spring-cloud-alibaba)
[![MySQL](https://img.shields.io/badge/MySQL-8.0.19-blue)](https://www.mysql.com/)
[![Redis](https://img.shields.io/badge/Redis-5.0.9-red)](https://redis.io/)
[![Nacos](https://img.shields.io/badge/Nacos-1.4.2-%23267DF7)](https://github.com/alibaba/nacos)
[![Vue](https://img.shields.io/badge/Vue-2.6.11-success)](https://cn.vuejs.org/)
[![Github Star](https://img.shields.io/github/stars/HimitZH/HOJ?style=social)](https://github.com/HimitZH/HOJ)
[![Gitee Star](https://gitee.com/himitzh0730/hoj/badge/star.svg)](https://gitee.com/himitzh0730/hoj)
[![QQ Group 598587305](https://img.shields.io/badge/QQ%20Group-598587305-blue)](https://qm.qq.com/cgi-bin/qm/qr?k=WWGBZ5gfDiBZOcpNvM8xnZTfUq7BT4Rs&jump_from=webapi)

Hcode Online Judge (HOJ) : 基于前后端分离，分布式架构的在线测评平台（hoj），前端使用vue，后端主要使用springboot，redis，mysql，nacos等技术，**支持HDU、POJ、Codeforces（包括GYM）、AtCoder、SPOJ的Remote Judge判题，同时适配手机端、电脑端浏览，拥有讨论区与站内消息系统，支持私有训练、公开训练（题单），支持团队功能，还有完善的判题模式（普通测评、特殊测评、交互测评、子任务评测）和完善的比赛功能（打星队伍、关注队伍、外榜、滚榜）。**

[Github 仓库](https://github.com/HimitZH/HOJ)
[Gitee 仓库](https://gitee.com/himitzh0730/hoj)

欢迎star收藏本项目对开发者的支持，谢谢  
有任何部署问题或项目bug请发issue或者加QQ群   
**如果要对本项目进行商业化，请在页面底部的Powered by指向HOJ本仓库地址**

[HDOI Onlie Judge](https://hdoi.cn/)

## 联系我们

QQ: [372347736](https://wpa.qq.com/msgrd?v=3&uin=372347736&site=qq&menu=yes)  
HOJ交流群: [598587305](https://qm.qq.com/cgi-bin/qm/qr?k=WWGBZ5gfDiBZOcpNvM8xnZTfUq7BT4Rs&jump_from=webapi)

## 支持我们

**如果您觉得hoj好用，想要支持一下开发者，项目的开发与维护需要资金，欢迎进行捐助。**  

**可以微信扫下方二维码支持一波，不必在乎多少，尽自己能力支持即可。**

![wxpy](/wxpay.png)