# 用例模式

:::info

​	HOJ的测试用例评测模式有以下几种：

​	**ACM题目**：默认（全部评测）、遇错止评（顺序评测）

​	**OI题目**：全部评测（得分加和）、子任务（最低得分）、子任务（平均得分）

:::

### 一、ACM题目

![ACM题目](https://img-blog.csdnimg.cn/f4f4a8bbe15e4ef1aa766524eaa6fbeb.png)

#### 1. 默认（全部评测）

:::tip

​	用户提交的代码将运行所有的测试用例，然后汇总结果。如果全部测试点都符合预期，则评测状态结果为**Accepted**，否则遍历所有测试点结果，将**第一个**非Accepted的测试点的状态作为最终结果。

:::

#### 2. 遇错止评（顺序评测）

:::tip

​	用户提交的代码将顺序运行所有测试用例，如果遇到某个测试点的结果（**非Accepted**）不符合预期，则评测结束，将该测试点的评测结果作为最终结果；否则一直遍历全部测试用例评测直至结束。

:::

### 二、OI题目

![OI题目](https://img-blog.csdnimg.cn/ecdd9ce03251440d9204bc728ef4d66b.png)



#### 1. 全部评测（得分加和）

:::tip

​	用户提交的代码将运行所有的测试用例，然后汇总所有评测点的得分和结果。如果全部测试点都符合预期，则评测状态结果为**Accepted**，得分为该题目的满分；否则遍历所有测试点结果，**加和所有测试点的得分**，作为该评测的最终得分。

:::

#### 2. 子任务（最低得分）

:::tip

​	将全部测试用例按照配置的组数分成多个子任务评测组，每个子任务**求该组测试点的最低得分**，作为该子任务的得分，然后**汇总加和所有子任务组的得分**，作为该评测的最终得分。

:::

![子任务](https://img-blog.csdnimg.cn/6b0404229b894d01aa98ee43bbb4d034.png)

#### 3. 子任务（平均得分）

:::tip

​	将全部测试用例按照配置的组数分成多个子任务评测组，每个子任务**加和该组所有测试点的得分求平均分**，作为该子任务的得分，然后**汇总加和所有子任务组的得分**，作为该评测的最终得分。

:::